//Windows header
#ifdef WIN32
#include <windows.h>
#endif


// OpenGL header
#include "gl.h"
#include "glut.h"

#include "solver.h"

// Solver :
Solver sol;

// Navigation dans la scne :
float zoom = 1;
float tx = 0, ty = 0;
bool doit = false;

////////////////////////////////////
//  Dessin :
////////////////////////////////////
void displayScene() {
	doit=true;
}

void idleScene() {
	glPushMatrix();
	if (doit) {
		glTranslatef(tx,ty,0);
		glScalef(zoom,zoom,zoom);
		// Display solution : 
		glLineWidth(3.0);
		glColor3f(0.0,0.0,0.0);
		glBegin(GL_LINES);
			glVertex2f(sol.pos.x,sol.pos.y);
			sol.callMethod();
			glVertex2f(sol.pos.x,sol.pos.y);
		glEnd();
		glPointSize(6.0);
		glColor3f(0,1,1);
		glBegin(GL_POINTS);
			glVertex2f(sol.pos.x,sol.pos.y);
		glEnd();
		glPointSize(12.0);
		glColor3f(0,0,1);
		glBegin(GL_POINTS);
			glVertex2f(sol.pos0.x,sol.pos0.y);
		glEnd();
		// Axes :
		glBegin(GL_LINES);
		glColor3f(1,0,0);
		glVertex2f(0,0);
		glVertex2f(1,0);
		glColor3f(0,1,0);
		glVertex2f(0,0);
		glVertex2f(0,1);
		glEnd();
		glFlush();
	}
	glPopMatrix();
}


////////////////////////////////////
//  Gestion d'vnements :
////////////////////////////////////
void specialKey(int key, int x_, int y_) {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT | GL_ACCUM_BUFFER_BIT);
	switch(key) {
		case GLUT_KEY_LEFT :
			tx -= zoom*0.1;
			sol.resetPos();
			break;
		case GLUT_KEY_RIGHT :
			tx += zoom*0.1;
			sol.resetPos();
			break;
		case GLUT_KEY_UP :
			ty += zoom*0.1;
			sol.resetPos();
			break;
		case GLUT_KEY_DOWN :
			ty -= zoom*0.1;
			sol.resetPos();
			break;
	}
	glutPostRedisplay();
}

void commonKey(unsigned char key, int x_, int y_) {
	switch(key) {
		case 27 :
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT | GL_ACCUM_BUFFER_BIT);
			exit(0);
		case ' ' :
			doit=true;
			break;
		case 'a' :
			zoom = zoom/2.0;
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT | GL_ACCUM_BUFFER_BIT);
			sol.resetPos();
			break;
		case 'z' :
			zoom = zoom*2.0;
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT | GL_ACCUM_BUFFER_BIT);
			sol.resetPos();
			break;
		default :
			return;
	}
}

void mouseClick(int button, int state, int x,int y) {
}

void mouseMotion(int x,int y) {
}

void changeSize(int w, int h)   {
	glViewport(0, 0, w, h);
	glScalef(1,(float)w/(float)h,1);
	glutPostRedisplay();
}


////////////////////////////////////
//  Mthodes d'initialisation :
////////////////////////////////////

// Initialisation :
void initScene(void) {
	// init GL states
	glLoadIdentity();
	glClearDepth(1.0);													
	glClearColor(1.0, 1.0, 1.0, 1.0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT | GL_ACCUM_BUFFER_BIT);
}

////////////////////////////////////
//  Main method
////////////////////////////////////
int main(int argc, char **argv) {
	// crer la fentre
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_SINGLE | GLUT_MULTISAMPLE);
	glutInitWindowPosition(100,100);
	glutInitWindowSize(800, 600);
	glutCreateWindow("Dynamics");

	// Evnements clavier/souris :
	glutSpecialFunc(specialKey);
	glutKeyboardFunc(commonKey);
	glutMouseFunc(mouseClick);
	glutMotionFunc(mouseMotion);
	
	// Mthodes de rendu :
	glutDisplayFunc(displayScene);
	glutIdleFunc(idleScene);

	// Changement de taille de la fentre :
	glutReshapeFunc(changeSize);

	// Initialise OpenGL :
	initScene();

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	// run program
	glutMainLoop();

	return(0);
}
