#ifndef MATRIX_H_
#define MATRIX_H_

#include <stdio.h>
#include "Vec.h"

class Matrix {
public :
	double _m[4]; // [m0 m2
				//   m1 m3]

public :
	Matrix(){};
	~Matrix(){};

	// Accesseur :
	double getVal(int i, int j) {return _m[i+2*j];};
	
	// Modifiers :
	void setM(double m00, double m10, double m01, double m11) {
		_m[0] = m00;
		_m[1] = m10;
		_m[2] = m10;
		_m[3] = m11;
	}
	void setVal(int i, int j, double val) {
		_m[i+2*j] = val;
	}
	void setIdentity() {
		_m[0] = 1.0;
		_m[1] = 0.0;
		_m[2] = 0.0;
		_m[3] = 1.0;
	}

	// Inversion :
	// retourne 0 si matrice non inversible
	// invM doit tre alloue : 4 doubles
	int inverseMatrix(double* invM);
	int inverseMatrix();

	// Multiplication par un vecteur :
	// vec doit tre alloue : 2 doubles
	// res doit tre alloue : 2 doubles
	void multMatVec(Vec vec, Vec* res);

	// Multiplication par un scalaire :
	void multMatSca(double k);

	void printMat() {
		printf("%f %f\n%f %f\n\n", _m[0], _m[2], _m[1], _m[3]);
	}
	
	// Oprateurs :
	friend Matrix operator+ (Matrix a, Matrix b) {
		Matrix res;
		res.setVal(0,0,a.getVal(0,0) + b.getVal(0,0));
		res.setVal(1,0,a.getVal(1,0) + b.getVal(1,0));
		res.setVal(0,1,a.getVal(0,1) + b.getVal(0,1));
		res.setVal(1,1,a.getVal(1,1) + b.getVal(1,1));
		return res;
	}
	friend Matrix operator- (Matrix a, Matrix b) {
		Matrix res;
		res.setVal(0,0,a.getVal(0,0) - b.getVal(0,0));
		res.setVal(1,0,a.getVal(1,0) - b.getVal(1,0));
		res.setVal(0,1,a.getVal(0,1) - b.getVal(0,1));
		res.setVal(1,1,a.getVal(1,1) - b.getVal(1,1));
		return res;
	}
};

#endif